<template>
  <div>
    <div class="select-style">
      Product
      <select id="product" v-model="productSelected" @change="setFilter">
        <option
          v-for="option in productOptions"
          :key="option.value"
          v-bind:value="option.value"
        >
          {{ option.text }}
        </option>
      </select>
    </div>

    <div class="select-style">
      CTA's
      <select id="cta" v-model="ctaSelected" @change="setFilter">
        <option
          v-for="option in ctaOptions"
          :key="option.value"
          v-bind:value="option.value"
        >
          {{ option.text }}
        </option>
      </select>
    </div>

    <div class="select-style">
      Names
      <select id="name" v-model="bloggerNameSelected" @change="setFilter">
        <option
          v-for="option in bloggerNameOptions"
          :key="option.value"
          v-bind:value="option.value"
        >
          {{ option.text }}
        </option>
      </select>
    </div>

    <!-- <div class="select-style">
      Ad
      <select id="adv" v-model="advSelected" @change="setFilter">
        <option
          v-for="option in advOptions"
          :key="option.value"
          v-bind:value="option.value"
        >
          {{ option.text }}
        </option>
      </select>
    </div> -->

    <!-- <div class="select-style">
        TYPE
        <br />
        <select id="newsletter_type">
          <option value="Normal">Regular</option>
          <option value="GS">Google</option>
        </select>
      </div> -->
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import Advertisement from "./Advertisement.vue";
import { ModalBus } from "../eventBus";

export default {
  emits: ["change-filter"],
  data() {
    return {
      productSelected: 8,
      productOptions: [
        { text: "8", value: 8 },
        { text: "6", value: 6 },
        { text: "4", value: 4 },
        { text: "3", value: 3 }
      ],
      ctaSelected: true,
      ctaOptions: [
        { text: "Yes", value: true },
        { text: "No", value: false }
      ],
      bloggerNameSelected: true,
      bloggerNameOptions: [
        { text: "Yes", value: true },
        { text: "No", value: false }
      ],
      advSelected: false,
      advOptions: [
        { text: "Yes", value: true },
        { text: "No", value: false }
      ],
      filter: {
        id: null,
        value: null
      }
    };
  },
  computed: {
    ...mapGetters([
      "GETTER_DATA_PRODUCT_OF_ROW",
      "GETTER_DATA_BLOGGER_NAME_ENABLE",
      "GETTER_DATA_BLOGGER_CTA_ENABLE"
    ])
  },
  watch: {
    GETTER_DATA_PRODUCT_OF_ROW() {
      this.productSelected = this.GETTER_DATA_PRODUCT_OF_ROW;
    },
    GETTER_DATA_BLOGGER_NAME_ENABLE() {
      this.bloggerNameSelected = this.GETTER_DATA_BLOGGER_NAME_ENABLE;
    },
    GETTER_DATA_BLOGGER_CTA_ENABLE() {
      this.ctaSelected = this.GETTER_DATA_BLOGGER_CTA_ENABLE;
    }
  },

  created() {
    if (localStorage.getItem("savedata")) {
      this.bloggerNameSelected = JSON.parse(
        localStorage.getItem("savedata")
      ).nameBloggerEnable;
      this.productSelected = JSON.parse(
        localStorage.getItem("savedata")
      ).productOfRow;
      this.ctaSelected = JSON.parse(
        localStorage.getItem("savedata")
      ).blogger_cta;
    }
  },
  methods: {
    setFilter(event) {
      this.filter.id = event.target.id;
      this.filter.value = event.target.value;
      this.$store.dispatch("ACTION_SET_FILTER", this.filter);
      if (event.target.id == "adv" && event.target.value === "true") {
        console.log("Add adv");
        ModalBus.$emit("open", {
          component: Advertisement,
          title: "Advertisement",
          closeOnClick: false
        });
      }
    }
  }
};
</script>

<style scoped>
.select-style {
  padding: 0 5px;
  font-size: 12px;
  display: inline-block;
}
</style>
